# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- build
- test
- review
- deploy
build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint:
    - ''
  script:
  - /kaniko/executor --context "${CI_PROJECT_DIR}" --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
    --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}"
test-code-job:
  stage: test
  script:
  - echo "If the files are built successfully, test some files with one command:"
deploy review:
  stage: review
  script:
  - echo "Do your average deploy here"
  rules:
  - if: "$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH"
    when: never
  - if: "$CI_COMMIT_TAG"
    when: never
  - when: always
  environment:
    name: review/$CI_COMMIT_REF_NAME
deploy release:
  stage: deploy
  script:
  - echo "Deploy to a production environment"
  rules:
  - if: "$CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH && $CI_COMMIT_TAG"
    when: manual
  environment:
    name: production
deploy staging:
  stage: deploy
  script:
  - echo "Deploy to a staging environment"
  rules:
  - if: "$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH"
    when: always
  - when: never
  environment:
    name: staging
variables:
  SECURE_LOG_LEVEL: debug
include:
- template: Security/Secret-Detection.gitlab-ci.yml
- template: Jobs/Dependency-Scanning.gitlab-ci.yml
- template: Security/SAST.gitlab-ci.yml
- template: Jobs/Container-Scanning.gitlab-ci.yml

secret_detection:
  variables:
    SECRET_DETECTION_HISTORIC_SCAN: 'false'
  rules:
  - if: "$CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH"
secret_detection_quick:
  extends: secret_detection
  variables:
    SECRET_DETECTION_HISTORIC_SCAN: 'true'
  rules:
  - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"

sast:
  stage: test

container_scanning:
  variables:
    CS_IMAGE: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}"
